Index: 23.5/configure.in
--- 23.5/configure.in Sun, 21 Jul 2002 17:31:45 +1000 kaos (modutils-2.4/14_configure. 1.10 644)
+++ 23.7/configure.in Wed, 29 Jan 2003 17:39:00 +1100 kaos (modutils-2.4/14_configure. 1.12 644)
@@ -190,11 +190,17 @@ else
 fi],[STRIP=$DEFAULT_STRIP])
 AC_SUBST(STRIP)
 
+# If zlib is required, libz must be linked static, insmod is in /sbin, libz is
+# in /usr/lib and may not be available when insmod is run.  But if insmod is
+# all static then we cannot use -Bdynamic at all, it confuses ld.
 AC_ARG_ENABLE(zlib,
 [  --disable-zlib               Do not handle gzipped objects (default)],
 [if test "$enableval" = "yes"; then
   AC_DEFINE(CONFIG_USE_ZLIB)
-  LIBS="$LIBS -lz"
+  zlib_flags="-Wl,-Bstatic -lz"
+  if test "$insmod_static" = "no"; then
+    zlib_flags="$zlib_flags -Wl,-Bdynamic"
+  fi
 fi])
 
 # Default for use-syscall depends on the presence of query_module in libc.
@@ -228,6 +234,11 @@ if test "$CFLAGS" = ""; then
 fi
 
 AC_PROG_CC
+# Delay adding the zlib_flags until after AC_PROG_CC, so we can distinguish
+# between a broken cc and a working cc but missing libz.a.  There are no
+# standard autoconf tests for the presence of a static library, so just set
+# LDFLAGS and let the link step check for libz.a.
+LDFLAGS="$LDFLAGS $zlib_flags"
 AC_PROG_RANLIB
 AC_PROG_LN_S
 